## "recast haps" is the process where reconcile differences between
## genotype posterior probabilities, which are the most accurate
## and 
## haploid dosages (haplotypes), which are phase accurate but less accurate for dosage / genotype posteriors
##
## basically when we do this, we will throw away haplotype dosages, as they become less obvious?

test_that("can recast haps", {

    skip("WIP")
    
    ## obvious options
    hd1 <- as.integer(c(0, 0, 0, 1))
    hd2 <- as.integer(c(0, 1, 1, 1))
    gp  <- matrix(0, nrow = 4, ncol = 3)
    gp[1, ] <- c(1, 0, 0)
    gp[2, ] <- c(0, 1, 0)
    gp[3, ] <- c(0, 1, 0)
    gp[4, ] <- c(0, 0, 1)
    out <- recast_haps(hd1, hd2, gp)
    expect_equal(hd1, out[, "i1"])
    expect_equal(hd2, out[, "i2"])
    
    ## still obvious
    hd1 <- c(0.49, 0.49)
    hd2 <- c(0.49, 0.49)
    gp  <- matrix(0, nrow = 2, ncol = 3)
    gp[1, ] <- c(1, 0, 0) ## hom ref
    gp[2, ] <- c(0.51, 0.49, 0) ## hom ref
    out <- recast_haps(hd1, hd2, gp)
    expect_equal(as.integer(hd1), out[, "i1"])
    expect_equal(as.integer(hd2), out[, "i2"])
    expect_equal(hd1, out[, "h1"])
    expect_equal(hd2, out[, "h2"])

    ## fun stuff
    hd1 <- c(0.49, 0.49)
    hd2 <- c(0.48, 0.48)
    gp  <- matrix(0, nrow = 2, ncol = 3)
    gp[1, ] <- c(0.49, 0.51, 0)
    gp[2, ] <- c(0, 0.51, 0.49)
    ## now need to be a het, with first one goes up
    out <- recast_haps(hd1, hd2, gp)
    out

    ## OK AM HERE
    ## THIS BROADLY SEEMS ON PACE
    ## THERE ARE A LOT OF WAYS THIS CAN GO WRONG< CODE THEM UP
    
    expect_equal(as.integer(hd1), out[, "i1"])
    expect_equal(as.integer(hd2), out[, "i2"])
    expect_equal(hd1, out[, "h1"])
    expect_equal(hd2, out[, "h2"])
    
    
    gp[2, ] <- c(0, 1, 0)
    gp[3, ] <- c(0, 1, 0)
    gp[4, ] <- c(0, 0, 1)
    

    ##
    gp <- matrix(c(0.6, 0.3, 0.1), nrow = 1)

    
    ## OK, so it can work, but might not!
    gp <- matrix(c(0.63, 0.34, 0.03), nrow = 1)    
    ds <- gp[, 2] + 2 * gp[, 3]
    (ds + c(-1, 1) * sqrt(ds**2 - 4 * gp[, 3])) / 2 ## OK
    

    ## AM HERE
    ## Do I want to re-cast the haplotype dosages?
    ## I think so, perhaps want the two haplotype dosages to, as near as possible, yield the genotype posteriors
    ## specifically maximize choice subject to constraint that they have to yield, when rounded, argmax of genotype
    
    ## so e.g., close
    h1 <- 0.3
    h2 <- 0.1
    c((1 - h1) * (1 - h2), (1 - h1) * h2 + h1 * (1 - h2), h1 * h2)
    
})

